/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001-2004  by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@gmx.de
 *    Borg Enders  borg@borgsoft.de
 *
 *********************************************************************/

#include "constants.h"

#ifdef USE_UI_GTK

#include "XGtkLabelAdjustment.h"

#include "../../../misc/language.h"

namespace GTK_DOKO {

  /**
   **
   ** constructor
   **
   ** @param	text	text for the label
   **
   ** @return	-
   ** 
   ** author	Diether Knof
   **
   ** @version	0.5.2
   **
   **/
  XGtkLabelAdjustment::XGtkLabelAdjustment(string const& text) :
    XGtkLabelWidget(text)
    {
      DEBUG_CALLING(INFO_GTK_WIDGET && INFO_GTK_INIT,
		    "XGtkLabelAdjustment::XGtkLabelAdjustment()");

      // set the text of the label widget
      this->language_update();

      // show all widgets
      gtk_widget_show_all(this->widget());

      DEBUG_RETURNING(VOID,
		      INFO_GTK_WIDGET && INFO_GTK_INIT,
		      "XGtkLabelAdjustment::XGtkLabelAdjustment()");
    } // XGtkLabelAdjustment::XGtkLabelAdjustment()

  /**
   **
   ** destructor
   **
   ** @param	-
   **
   ** @return	-
   ** 
   ** author	Diether Knof
   **
   ** @version	0.5.2
   **
   **/
  XGtkLabelAdjustment::~XGtkLabelAdjustment()
  {
    DEBUG_CALLING(INFO_GTK_WIDGET && INFO_GTK_INIT,
		  "XGtkLabelAdjustment::~XGtkLabelAdjustment()");

    DEBUG_RETURNING(VOID,
		    INFO_GTK_WIDGET && INFO_GTK_INIT,
		    "XGtkLabelAdjustment::~XGtkLabelAdjustment()");
  } // XGtkLabelAdjustment::XGtkLabelAdjustment()

  /**
   **
   ** -> result
   **
   ** @param	-
   **
   ** @return	the adjustment
   ** 
   ** author	Diether Knof
   **
   ** @version	0.5.2
   **
   **/
  GtkAdjustment*
    XGtkLabelAdjustment::adjustment()
    {
      DEBUG_CALLING(INFO_GTK_WIDGET && INFO_GTK_VALUE,
		    "XGtkLabelAdjustment::adjustment()");

      DEBUG_ASSERTION(false,
		      "XGtkLabelAdjustment::adjustment()\n"
		      "  call of this virtual function");

      DEBUG_RETURNING(NULL,
		      INFO_GTK_WIDGET && INFO_GTK_VALUE,
		      "XGtkLabelAdjustment::adjustment()");
    } // virtual GtkAdjustment* XGtkLabelAdjustment::adjustment()

  /**
   **
   ** -> result
   **
   ** @param	-
   **
   ** @return	the widget with the adjustment
   ** 
   ** author	Diether Knof
   **
   ** @version	0.5.2
   **
   **/
  GtkWidget*
    XGtkLabelAdjustment::adjustment_widget()
    {
      DEBUG_CALLING(INFO_GTK_WIDGET && INFO_GTK_VALUE,
		    "XGtkLabelAdjustment::adjustment_widget()");

      DEBUG_ASSERTION(false,
		      "XGtkLabelAdjustment::adjustment_widget()\n"
		      "  call of this virtual function");

      DEBUG_RETURNING(NULL,
		      INFO_GTK_WIDGET && INFO_GTK_VALUE,
		      "XGtkLabelAdjustment::adjustment_widget()");
    } // virtual GtkWidget* XGtkLabelAdjustment::adjustment_widget()

  /**
   **
   ** sets the minimum and the maximum of the adjustment
   **
   ** @param	min	the new minimum
   ** @param	max	the new maximum
   **
   ** @return	-
   ** 
   ** author	Diether Knof
   **
   ** @version	0.5.2
   **
   **/
  void
    XGtkLabelAdjustment::minmax_set(int const min, int const max)
    {
      DEBUG_CALLING(INFO_GTK_WIDGET && INFO_GTK_VALUE,
		    "XGtkLabelAdjustment::minmax_set(min, max)");

      DEBUG_ASSERTION(false,
		      "XGtkLabelAdjustment::minmax_set(min, max)\n"
		      "  call of this virtual function");

      DEBUG_RETURNING(VOID,
		      INFO_GTK_WIDGET && INFO_GTK_VALUE,
		      "XGtkLabelAdjustment::minmax_set(min, max)");
    } // virtual GtkWidget* XGtkLabelAdjustment::minmax_set(int const min, int const max)

  /**
   **
   ** sets the value
   **
   ** @param	value	the new value
   **
   ** @return	-
   ** 
   ** author	Diether Knof
   **
   ** @version	0.5.2
   **
   **/
  void
    XGtkLabelAdjustment::value_set(unsigned const value)
    {
      DEBUG_CALLING(INFO_GTK_WIDGET && INFO_GTK_VALUE,
		    "XGtkLabelAdjustment::value_set(value)");

      DEBUG_ASSERTION(false,
		      "XGtkLabelAdjustment::value_set(value)\n"
		      "  call of this virtual function");

      DEBUG_RETURNING(VOID,
		      INFO_GTK_WIDGET && INFO_GTK_VALUE,
		      "XGtkLabelAdjustment::value_set(value)");
    } // virtual GtkWidget* XGtkLabelAdjustment::value_set(unsigned const value)

  /**
   **
   ** -> result
   **
   ** @param	-
   **
   ** @return	the value
   ** 
   ** author	Diether Knof
   **
   ** @version	0.5.2
   **
   **/
  unsigned
    XGtkLabelAdjustment::value()
    {
      DEBUG_CALLING(INFO_GTK_WIDGET && INFO_GTK_VALUE,
		    "XGtkLabelAdjustment::value()");

      DEBUG_ASSERTION(false,
		      "XGtkLabelAdjustment::value()\n"
		      "  call of this virtual function");

      DEBUG_RETURNING(UINT_MAX,
		      INFO_GTK_WIDGET && INFO_GTK_VALUE,
		      "XGtkLabelAdjustment::value()");
    } // virtual GtkWidget* XGtkLabelAdjustment::value()

} // namespace GTK_DOKO
#endif // #ifdef USE_UI_GTK
